'Reactive LASER Target Using a PICAXE-08M2
'PICAXE Tutorial
'Experiment: Reactive LASER Target
'9 Feb 2016
'Schematic: Reactive LASER Target.dch
'Code: Reactive LASER Target.bas
'Overview: Use a PICAXE-08M2 to read a phototransistor
	'and react to a brief pulse of LASER light by activating
	'an output on the 08M2 and lighting an LED.

#picaxe 08M2 'Identify the PICAXE being used as an 08M2.
#no_data 'Prevent data from being downloaded to PICAXE.

symbol shoot_time = w2 'variable for shoot_time value storage
symbol N = w3 'variable for loop counter storage
symbol ready = C.1 'variable for "Ready" LED
symbol hit_indicator = C.2 'variable for "Hit" LED
symbol hit = pinC.3 'variable for hit signal input
symbol set_time = C.4 'variable for ADC time set input

main:
shoot_time = 0 'Reset shoot_time variable to zero.
N = 0 'Reset hit_check counter to 0.
readadc set_time, shoot_time 'Read set_time into shoot_time variable.
shoot_time = shoot_time * 10 'Set maximum shoot_time to 15 seconds.
high ready 'Turn on "Ready" LED.
for N = 1 to shoot_time 'Set number of loops to equal shoot_time.
	gosub hit_check
next N 'Next loop.
low ready 'Turn off "Ready" LED.
pause 5000 'Pause before beginning next cycle.
goto main

hit_check:
	if hit = 0 then 'If Q2 drain is low, then
		high hit_indicator 'Turn on "Hit" LED
		low ready 'and turn off "Ready LED.
		pause 3000 'Pause to allow time to observe "Hit" LED.
		low hit_indicator 'Turn off "Hit" LED.
		pause 3000 'Pause before beginning next cycle.
		goto main
	endif
return